import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Professor findHighestPaidByDepartment(Department dept) {
    try {
        return (Professor) em.createNamedQuery("findHighestPaidByDepartment")
                            .setParameter("dept", dept)
                            .getSingleResult();
    } catch (NoResultException e) {
        return null;
    }
}

}
